int nP=2; // number of players (fixed to 2 for now)
int score[] = new int[nP];  // current scores
int cp=0;                   // current player
boolean hitn, hitnn;        // track whether the next and previous balls have been hit during this shot
int goal = 13;              // goal score to win
float ml=120; // max length of initial velocity when the ball is hit by the queue
boolean stopped = false;  // true when all balls have stoppedboolean predict = true;   // true if the correct prediction is used
int nB = 5;                // total number of balls
BALL[] B = new BALL[nB];   // table of balls
int c=2;                  // current ball (playable balls are 2, 3, and 4 only)
float gr=0.045;             // radius of small playable  balls
float f=0.09;            // friction factor for slowing down the balls

void myActions() {                                  // actions to be executed at each frame
    fill(black); text(str(score[0]),20,30); text(str(score[1]),width-120,30); noFill();      // show scores
    if(stopped) {
      if((score[0]==goal)&&(score[1]<goal)) {fill(dred);text("won",20,50);}
      else if((score[1]==goal)&&(score[0]<goal)) {fill(dred);text("won",width-70,50);}
      else {fill(black); if(cp==0) text("play",20,50); else text("play",width-70,50);};
       }  // shows who should play now (when all balls stopped)
    else {fill(black); if(cp==0) text("playing",20,50); else text("playing",width-70,50);};  // show who was the last one to play
    if ((mousePressed)&&(!keyPressed)&&stopped) {    // when balls stopped and mouse is down, we show the pool and the rubberband arrow from the queue
       showBalls(); 
       stroke(grey); fill(grey); strokeWeight(2); vec U = V(B[c].C, mouse()); if (n(U)>ml) U=S(ml,U(U)); pt S=S(B[c].C,U); arrow(S,-1,U); noStroke(); noFill(); // arrow
       } 
     else step();   // balls are still rolling, we compute the next frame and show it (see TAB balls)
    stroke(yellow); B[c].drawBall();  // shows the current ball using a black ring around it
   };

int next(int c) {if(c==4) return 2; else return c+1;};  // computes next ball in circular list (2,3,4)
class BALL {
  pt C ; vec V ; float r; float m; color c;  // center, velocity, radius, mass, color of ball
  BALL (pt pC, vec pV, float pr, float pm, color pc) {C=pC; V=pV; r=pr; m=pm; c=pc;};
  void show() {fill(c); C.show(abs(r));}; 
  void drawBall() {noFill(); strokeWeight(2); C.show(abs(r)); noStroke(); strokeWeight(1);}; 
  void showV() {arrow(C,V);}; 
  void move() { C.translateBy(V); };
  void move(float t) { C.translateBy(t,V); };
  void slowdown() {if(n(V)<f) V=V(0,0); else V.add(S(-f,U(V)));}; //  slow down the ball
  }
void rollBalls() {for(int i=2; i<nB; i++) B[i].move();}         // advances all balls by their velocity (used in sampled collision)
void rollBalls(float t) {for(int i=2; i<nB; i++) B[i].move(t);} // advances all balls by time computed with exact collision
void showBalls() {for(int i=0; i<nB; i++) B[i].show();}         // show all balls
void slowBalls() {for(int i=0; i<nB; i++) B[i].slowdown();}     // slows down all balls at each frame
void declareBalls() { // make the scene
  B[0]=new BALL(P(width/2,height/2),V(0,0),-0.45*width,pow(2,30),color(30, 60, 30));  // outer ball
  B[1]=new BALL(P(width/2,height/2),V(0,0),gr*width,pow(2,30),white);  // inner hole
  B[2]=new BALL(P(width/4,height/2),V(0,0),gr*width,1,red);  // playable red ball
  B[3]=new BALL(R(P(width/4,height/2),toRad(120),screenCenter()),V(0,0),gr*width,1,green);  
  B[4]=new BALL(R(P(width/4,height/2),toRad(240),screenCenter()),V(0,0),gr*width,1,cyan);  
  }; 

void step() {   // computes next frame
      float rm=1;   // time remaining till next frame or first collision
      while(rm>0) {  // repeat process of detecting collision, advancing till that time, and computing new velocities after shock
        int k=-1,l=-1;  // tracks shich pair of balls collide first
        float m=rm;     // time remaining till next frame
        for (int i=0; i<nB-1; i++)  for (int j=i+1; j<nB; j++) { // for all balls
          float t=collision(B[i],B[j]); // collision time (or 2)
          boolean bang = ((i*j==0) != approaching(B[i],B[j])) ;  //* centers of small balls are approaching (or small ball is approaching rim)
          if((t<m)&&bang) { //* if this collision happens before the next frame and before any collision found so far
            m=t;k=i;l=j; // update time of collision and colliding pair
            if(((j==c)&&(i==next(c)))||((i==c)&&(j==next(c)))) hitn=true;  
            if(((j==c)&&(i==next(next(c))))||((i==c)&&(j==next(next(c))))) hitnn=true;  
            };
          };
        rollBalls(m); 
        if(k>-1) shock(B[k],B[l]);
        rm-=m;
        };
  slowBalls();
  showBalls();
  if(!stopped&&(n(B[2].V)==0)&&(n(B[3].V)==0)&&(n(B[4].V)==0)) { // when the last rolling ball just stopped
      if(hitn&&hitnn) score[cp]++; else cp=1-cp; stopped=true; c=next(c); hitn=false; hitnn=false;}; // reset scores, current ball, and player for next shot
  if(hitn) {stroke(orange); B[next(c)].drawBall();}; if(hitnn) {stroke(orange); B[next(next(c))].drawBall();}; // show which balls have been already hit in this shot
  }
  
float collision(BALL A, BALL B) {   // computes collision time t and returns it if 0<t<1. Otherwise, returns 2
  vec W=M(-1,A.V,1,B.V); vec D=V(A.C,B.C); float a=dot(W,W); float b=2*dot(D,W); float c=dot(D,D)-sq(A.r+B.r); // coeffs of quadratic equation
  float d=sq(b)-4*a*c; // discriminant of quadratic equation
  if (d>=0) {float t1=(-b-sqrt(d))/2/a; if(t1<0) t1=2; float t2=(-b+sqrt(d))/2/a; if(t2<0) t2=2; float m=min(t1,t2); 
              if ((-0.02<=m)&&(m<=1.02)) return m; } //* 
  return 2; }
  
void shock(BALL A, BALL B) {// computes new velocities for elastic shock
   vec N = U(V(A.C,B.C)); vec D=S(dot(M(-1,A.V,1,B.V),N),N); A.V.setTo(M(1,A.V,2*B.m/(A.m+B.m),D)); B.V.setTo(M(1,B.V,-2*A.m/(A.m+B.m),D));} 

boolean interfere(BALL A, BALL B) {if(A.r>0) return d(A.C,B.C)<=A.r+B.r+0.01 ; else return d(A.C,B.C)>=-A.r-B.r-0.01 ; }  //* if balls interfere 
boolean approaching(BALL A, BALL B) {vec N = V(A.C,B.C); return dot(N,M(1,B.V,-1,A.V))<0; }  //* approaching balls 
